diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c olsrd-current/lib/bmf/src/NetworkInterfaces.c
--- olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c	2007-02-11 12:51:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/NetworkInterfaces.c	2007-04-22 19:40:38.000000000 +0200
@@ -488,19 +1162,12 @@
   /* Set socket to blocking operation */
   if (fcntl(skfd, F_SETFL, fcntl(skfd, F_GETFL, 0) & ~O_NONBLOCK) < 0)
   {
-    olsr_printf(1, "%s: fcntl() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("fcntl() error");
     close(skfd);
     return -1;
   }
 
-  /* Keep the highest-numbered descriptor */
-  if (skfd > HighestSkfd)
-  {
-    HighestSkfd = skfd;
-  }
-
-  /* Add descriptor to input set */
-  FD_SET(skfd, &InputSet);
+  AddDescriptorToInputSet(skfd);
 
   return skfd;
 }
@@ -525,13 +1192,13 @@
   static char* deviceName = "/dev/net/tun";
   struct ifreq ifreq;
   int etfd;
-  int ioctl_s;
+  int ioctlSkfd;
   int ioctlres;
 
   etfd = open(deviceName, O_RDWR | O_NONBLOCK);
   if (etfd < 0)
   {
-    olsr_printf(1, "%s: error opening %s: %s\n", PLUGIN_NAME, deviceName, strerror(errno));
+    BmfPError("error opening %s", deviceName);
     return -1;
   }
 
@@ -553,7 +1220,7 @@
 
   if (ioctl(etfd, TUNSETIFF, (void *)&ifreq) < 0)
   {
-    olsr_printf(1, "%s: ioctl(TUNSETIFF) error on %s: %s\n", PLUGIN_NAME, deviceName, strerror(errno));
+    BmfPError("ioctl(TUNSETIFF) error on %s", deviceName);
     close(etfd);
     return -1;
   }
@@ -563,10 +1230,10 @@
   ifreq.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
   ifreq.ifr_addr.sa_family = AF_INET;
 
-  ioctl_s = socket(PF_INET, SOCK_DGRAM, 0);
-  if (ioctl_s < 0)
+  ioctlSkfd = socket(PF_INET, SOCK_DGRAM, 0);
+  if (ioctlSkfd < 0)
   {
-    olsr_printf(1, "%s: socket(PF_INET) error on %s: %s\n", PLUGIN_NAME, deviceName, strerror(errno));
+    BmfPError("socket(PF_INET) error on %s", deviceName);
     close(etfd);
     return -1;
   }
@@ -585,7 +1252,7 @@
 
       if (bmfIf->olsrIntf != NULL)
       {
-        EtherTunTapIp = ntohl(((struct sockaddr_in*)&bmfIf->intAddr)->sin_addr.s_addr);
+        EtherTunTapIp = ntohl(bmfIf->intAddr.v4);
         EtherTunTapIpBroadcast = EtherTunTapIp;
       }
     }
@@ -599,25 +1266,25 @@
   }
 
   ((struct sockaddr_in*)&ifreq.ifr_addr)->sin_addr.s_addr = htonl(EtherTunTapIp);
-  ioctlres = ioctl(ioctl_s, SIOCSIFADDR, &ifreq);
+  ioctlres = ioctl(ioctlSkfd, SIOCSIFADDR, &ifreq);
   if (ioctlres >= 0)
   {
     /* Set net mask */
     ((struct sockaddr_in*)&ifreq.ifr_netmask)->sin_addr.s_addr = htonl(EtherTunTapIpMask);
-    ioctlres = ioctl(ioctl_s, SIOCSIFNETMASK, &ifreq);
+    ioctlres = ioctl(ioctlSkfd, SIOCSIFNETMASK, &ifreq);
     if (ioctlres >= 0)
     {
       /* Set broadcast IP */
       ((struct sockaddr_in*)&ifreq.ifr_broadaddr)->sin_addr.s_addr = htonl(EtherTunTapIpBroadcast);
-      ioctlres = ioctl(ioctl_s, SIOCSIFBRDADDR, &ifreq);
+      ioctlres = ioctl(ioctlSkfd, SIOCSIFBRDADDR, &ifreq);
       if (ioctlres >= 0)
       {
         /* Bring EtherTunTap interface up (if not already) */
-        ioctlres = ioctl(ioctl_s, SIOCGIFFLAGS, &ifreq);
+        ioctlres = ioctl(ioctlSkfd, SIOCGIFFLAGS, &ifreq);
         if (ioctlres >= 0)
         {
           ifreq.ifr_flags |= (IFF_UP | IFF_RUNNING | IFF_BROADCAST);
-          ioctlres = ioctl(ioctl_s, SIOCSIFFLAGS, &ifreq);
+          ioctlres = ioctl(ioctlSkfd, SIOCSIFFLAGS, &ifreq);
         }
       }
     }
@@ -626,15 +1293,10 @@
   if (ioctlres < 0)
   {
     /* Any of the above ioctl() calls failed */
-    olsr_printf(
-      1,
-      "%s: error bringing up EtherTunTap interface \"%s\": %s\n",
-      PLUGIN_NAME,
-      EtherTunTapIfName,
-      strerror(errno));
+    BmfPError("error bringing up EtherTunTap interface \"%s\"", EtherTunTapIfName);
 
     close(etfd);
-    close(ioctl_s);
+    close(ioctlSkfd);
     return -1;
   } /* if (ioctlres < 0) */
 
@@ -643,21 +1305,17 @@
   strncpy(ifreq.ifr_name, EtherTunTapIfName, IFNAMSIZ - 1);
   ifreq.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
 
-  ioctlres = ioctl(ioctl_s, SIOCGIFFLAGS, &ifreq);
+  ioctlres = ioctl(ioctlSkfd, SIOCGIFFLAGS, &ifreq);
   if (ioctlres >= 0)
   {
     ifreq.ifr_flags |= IFF_MULTICAST;
-    ioctlres = ioctl(ioctl_s, SIOCSIFFLAGS, &ifreq);
+    ioctlres = ioctl(ioctlSkfd, SIOCSIFFLAGS, &ifreq);
   }
   if (ioctlres < 0)
   {
     /* Any of the two above ioctl() calls failed */
-    olsr_printf(
-      1,
-      "%s: error setting multicast flag on EtherTunTap interface \"%s\": %s\n",
-      PLUGIN_NAME,
-      EtherTunTapIfName,
-      strerror(errno));
+    BmfPError("error setting multicast flag on EtherTunTap interface \"%s\"", EtherTunTapIfName);
+
     /* Continue anyway */
   }
 
@@ -666,32 +1324,18 @@
    * daemon (e.g. mrouted) may be using the tuntap interface. */
   if (ioctl(etfd, TUNSETPERSIST, (void *)&ifreq) < 0)
   {
-    olsr_printf(
-      1,
-      "%s: error making EtherTunTap interface \"%s\" persistent: %s\n",
-      PLUGIN_NAME,
-      EtherTunTapIfName,
-      strerror(errno));
+    BmfPError("error making EtherTunTap interface \"%s\" persistent", EtherTunTapIfName);
+
     /* Continue anyway */
   }
 
-  /* Deactivate IP spoof filter for EtherTunTap interface */
-  DeactivateSpoofFilter(EtherTunTapIfName);
+  OLSR_PRINTF(8, "%s: opened 1 socket on \"%s\"\n", PLUGIN_NAME_SHORT, EtherTunTapIfName);
 
-  OLSR_PRINTF(9, "%s: opened 1 socket on \"%s\"\n", PLUGIN_NAME_SHORT, EtherTunTapIfName);
-
-  /* Keep the highest-numbered descriptor */
-  if (etfd > HighestSkfd)
-  {
-    HighestSkfd = etfd;
-  }
-
-  /* Add descriptor to input set */
-  FD_SET(etfd, &InputSet);
+  AddDescriptorToInputSet(etfd);
 
   /* If the user configured a specific IP address for the BMF network interface,
    * help the user and advertise the IP address of the BMF network interface
-   * on the OLSR network */
+   * on the OLSR network via HNA */
   if (TunTapIpOverruled != 0)
   {
     union olsr_ip_addr temp_net;
@@ -702,67 +1346,11 @@
     add_local_hna4_entry(&temp_net, &temp_netmask);
   }
 
-  /* If the BMF network interface has a sensible IP address, it is a good idea
-   * to route all multicast traffic through that interface */
-  if (EtherTunTapIp != ETHERTUNTAPDEFAULTIP)
-  {
-    struct rtentry kernel_route;
-
-    memset(&kernel_route, 0, sizeof(struct rtentry));
-
-    ((struct sockaddr_in*)&kernel_route.rt_dst)->sin_family = AF_INET;
-    ((struct sockaddr_in*)&kernel_route.rt_gateway)->sin_family = AF_INET;
-    ((struct sockaddr_in*)&kernel_route.rt_genmask)->sin_family = AF_INET;
-
-    /* 224.0.0.0/4 */
-    ((struct sockaddr_in *)&kernel_route.rt_dst)->sin_addr.s_addr = htonl(0xE0000000);
-    ((struct sockaddr_in *)&kernel_route.rt_genmask)->sin_addr.s_addr = htonl(0xF0000000);
-
-    kernel_route.rt_metric = 0;
-    kernel_route.rt_flags = RTF_UP;
-
-    kernel_route.rt_dev = EtherTunTapIfName;
-
-    if (ioctl(ioctl_s, SIOCADDRT, &kernel_route) < 0)
-    {
-      olsr_printf(
-        1,
-        "%s: error setting multicast route via EtherTunTap interface \"%s\": %s\n",
-        PLUGIN_NAME,
-        EtherTunTapIfName,
-        strerror(errno));
-      /* Continue anyway */
-    }
-  }
-
-  close(ioctl_s);
+  close(ioctlSkfd);
 
   return etfd;
 }
 
-#if 0
-/* -------------------------------------------------------------------------
- * Function   : IsNullMacAddress
- * Description: Checks if a MAC address is all-zeroes
- * Input      : mac - address to check
- * Output     : none
- * Return     : true (1) or false (0)
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-static int IsNullMacAddress(char* mac)
-{
-  int i;
-
-  assert(mac != NULL);
-
-  for (i = 0; i < IFHWADDRLEN; i++)
-  {
-    if (mac[i] != 0) return 0;
-  }
-  return 1;
-}
-#endif
-
 /* -------------------------------------------------------------------------
  * Function   : CreateInterface
  * Description: Create a new TBmfInterface object and adds it to the global
@@ -772,7 +1360,7 @@
  *                NULL if the network interface is not OLSR-enabled
  * Output     : none
  * Return     : the number of opened sockets
- * Data Used  : none
+ * Data Used  : BmfInterfaces, LastBmfInterface
  * ------------------------------------------------------------------------- */
 static int CreateInterface(
   const char* ifName,
@@ -780,6 +1368,7 @@
 {
   int capturingSkfd = -1;
   int encapsulatingSkfd = -1;
+  int listeningSkfd = -1;
   int ioctlSkfd;
   struct ifreq ifr;
   int nOpened = 0;
@@ -794,7 +1383,7 @@
 
   if (olsrIntf != NULL)
   {
-    /* On OLSR interfaces, create socket for encapsulating and forwarding 
+    /* On OLSR-enabled interfaces, create socket for encapsulating and forwarding 
      * multicast packets */
     encapsulatingSkfd = CreateEncapsulateSocket(ifName);
     if (encapsulatingSkfd < 0)
@@ -820,6 +1409,22 @@
     nOpened++;
   }
 
+  /* Create promiscuous mode listening interface if BMF uses IP unicast
+   * as underlying forwarding mechanism */
+  if (BmfMechanism == BM_UNICAST_PROMISCUOUS)
+  {
+    listeningSkfd = CreateListeningSocket(ifName);
+    if (listeningSkfd < 0)
+    {
+      close(listeningSkfd);
+      close(encapsulatingSkfd); /* no problem if 'encapsulatingSkfd' is -1 */
+      free(newIf);
+      return 0;
+    }
+
+    nOpened++;
+  }
+
   /* For ioctl operations on the network interface, use either capturingSkfd
    * or encapsulatingSkfd, whichever is available */
   ioctlSkfd = (capturingSkfd >= 0) ? capturingSkfd : encapsulatingSkfd;
@@ -830,43 +1435,27 @@
   ifr.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
   if (ioctl(ioctlSkfd, SIOCGIFHWADDR, &ifr) < 0)
   {
-    olsr_printf(
-      1,
-      "%s: ioctl(SIOCGIFHWADDR) error for interface \"%s\": %s\n",
-      PLUGIN_NAME,
-      ifName,
-      strerror(errno));
-    close(capturingSkfd);
-    close(encapsulatingSkfd);
-    free(newIf);
-    return 0;
-  }
-
-  /* If null-interface, cancel the whole creation and return NULL */
-  /* -- Not needed, all goes well with interfaces that have a
-   * null-address, such as ppp interfaces. */
-  /*
-  if (IsNullMacAddress(ifr.ifr_hwaddr.sa_data))
-  {
+    BmfPError("ioctl(SIOCGIFHWADDR) error for interface \"%s\"", ifName);
     close(capturingSkfd);
     close(encapsulatingSkfd);
     free(newIf);
     return 0;
   }
-  */
 
   /* Copy data into TBmfInterface object */
   newIf->capturingSkfd = capturingSkfd;
   newIf->encapsulatingSkfd = encapsulatingSkfd;
+  newIf->listeningSkfd = listeningSkfd;
   memcpy(newIf->macAddr, ifr.ifr_hwaddr.sa_data, IFHWADDRLEN);
   memcpy(newIf->ifName, ifName, IFNAMSIZ);
   newIf->olsrIntf = olsrIntf;
   if (olsrIntf != NULL)
   {
     /* For an OLSR-interface, copy the interface address and broadcast
-     * address from the OLSR interface object */
-    newIf->intAddr = olsrIntf->int_addr;
-    newIf->broadAddr = olsrIntf->int_broadaddr;
+     * address from the OLSR interface object. Downcast to correct sockaddr
+     * subtype. */
+    COPY_IP(&newIf->intAddr, &((struct sockaddr_in *)&olsrIntf->int_addr)->sin_addr.s_addr);
+    COPY_IP(&newIf->broadAddr, &((struct sockaddr_in *)&olsrIntf->int_broadaddr)->sin_addr.s_addr);
   }
   else
   {
@@ -876,18 +1465,14 @@
     ifr.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
     if (ioctl(ioctlSkfd, SIOCGIFADDR, &ifr) < 0) 
     {
-      olsr_printf(
-        1,
-        "%s: ioctl(SIOCGIFADDR) error for interface \"%s\": %s\n",
-        PLUGIN_NAME,
-        ifName,
-        strerror(errno));
+      BmfPError("ioctl(SIOCGIFADDR) error for interface \"%s\"", ifName);
 
-      ((struct sockaddr_in*)&newIf->intAddr)->sin_addr.s_addr = inet_addr("0.0.0.0");
+      newIf->intAddr.v4 = inet_addr("0.0.0.0");
 	  }
 	  else
 	  {
-      newIf->intAddr = ifr.ifr_addr;
+      /* Downcast to correct sockaddr subtype */
+      COPY_IP(&newIf->intAddr, &((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr.s_addr);
     }
 
     /* For a non-OLSR interface, retrieve the IP broadcast address ourselves */
@@ -896,18 +1481,14 @@
     ifr.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
     if (ioctl(ioctlSkfd, SIOCGIFBRDADDR, &ifr) < 0) 
     {
-      olsr_printf(
-        1,
-        "%s: ioctl(SIOCGIFBRDADDR) error for interface \"%s\": %s\n",
-        PLUGIN_NAME,
-        ifName,
-        strerror(errno));
+      BmfPError("ioctl(SIOCGIFBRDADDR) error for interface \"%s\"", ifName);
 
-      ((struct sockaddr_in*)&newIf->broadAddr)->sin_addr.s_addr = inet_addr("0.0.0.0");
+      newIf->broadAddr.v4 = inet_addr("0.0.0.0");
 	  }
 	  else
 	  {
-      newIf->broadAddr = ifr.ifr_broadaddr;
+      /* Downcast to correct sockaddr subtype */
+      COPY_IP(&newIf->broadAddr, &((struct sockaddr_in *)&ifr.ifr_broadaddr)->sin_addr.s_addr);
     }
   }
 
@@ -915,12 +1496,35 @@
   memset(&newIf->fragmentHistory, 0, sizeof(newIf->fragmentHistory));
   newIf->nextFragmentHistoryEntry = 0;
 
-  /* Add new TBmfInterface object to global list */
-  newIf->next = BmfInterfaces;
-  BmfInterfaces = newIf;
+  /* Reset counters */
+  newIf->nBmfPacketsRx = 0;
+  newIf->nBmfPacketsRxDup = 0;
+  newIf->nBmfPacketsTx = 0;
+
+  /* Add new TBmfInterface object to global list. OLSR interfaces are
+   * added at the front of the list, non-OLSR interfaces at the back. */
+  if (BmfInterfaces == NULL)
+  {
+    /* First TBmfInterface object in list */
+    BmfInterfaces = newIf;
+    LastBmfInterface = newIf;
+  }
+  else if (olsrIntf != NULL)
+  {
+    /* Add new TBmfInterface object at front of list */
+    newIf->next = BmfInterfaces;
+    BmfInterfaces = newIf;
+  }
+  else
+  {
+    /* Add new TBmfInterface object at back of list */
+    newIf->next = NULL;
+    LastBmfInterface->next= newIf;
+    LastBmfInterface = newIf;
+  }
 
   OLSR_PRINTF(
-    9,
+    8,
     "%s: opened %d socket%s on %s interface \"%s\"\n",
     PLUGIN_NAME_SHORT,
     nOpened,
@@ -955,11 +1559,7 @@
   skfd = socket(PF_INET, SOCK_DGRAM, 0);
   if (skfd < 0)
   {
-    olsr_printf(
-      1,
-      "%s: no inet socket available to retrieve interface list: %s\n",
-      PLUGIN_NAME,
-      strerror(errno));
+    BmfPError("no inet socket available to retrieve interface list");
     return -1;
   }
 
@@ -972,7 +1572,7 @@
 
     if (ioctl(skfd, SIOCGIFCONF, &ifc) < 0)
     {
-      olsr_printf(1, "%s: ioctl(SIOCGIFCONF) error: %s\n", PLUGIN_NAME, strerror(errno));
+      BmfPError("ioctl(SIOCGIFCONF) error");
 
       close(skfd);
       free(ifc.ifc_buf);
@@ -995,9 +1595,15 @@
   for (n = ifc.ifc_len / sizeof(struct ifreq); --n >= 0; ifr++)
   {
     struct interface* olsrIntf;
+    union olsr_ip_addr ipAddr;
+
+    /* Skip the BMF network interface itself */
+    if (strncmp(ifr->ifr_name, EtherTunTapIfName, IFNAMSIZ) == 0)
+    {
+      continue; /* for (n = ...) */
+    }
 
     /* ...find the OLSR interface structure, if any */
-    union olsr_ip_addr ipAddr;
     COPY_IP(&ipAddr, &((struct sockaddr_in*)&ifr->ifr_addr)->sin_addr.s_addr);
     olsrIntf = if_ifwithaddr(&ipAddr);
 
@@ -1073,14 +1679,19 @@
  *              Also restores the network state to the situation before BMF
  *              was started.
  * ------------------------------------------------------------------------- */
-
-void CloseBmfNetworkInterfaces()
+void CloseBmfNetworkInterfaces(void)
 {
   int nClosed = 0;
-  
+  u_int32_t totalOlsrBmfPacketsRx = 0;
+  u_int32_t totalOlsrBmfPacketsRxDup = 0;
+  u_int32_t totalOlsrBmfPacketsTx = 0;
+  u_int32_t totalNonOlsrBmfPacketsRx = 0;
+  u_int32_t totalNonOlsrBmfPacketsRxDup = 0;
+  u_int32_t totalNonOlsrBmfPacketsTx = 0;
+
   /* Close all opened sockets */
   struct TBmfInterface* nextBmfIf = BmfInterfaces;
-  while (nextBmfIf != NULL)
+  while (nextBmfIf != NULL) 
   {
     struct TBmfInterface* bmfIf = nextBmfIf;
     nextBmfIf = bmfIf->next;
@@ -1097,61 +1708,65 @@
     }
 
     OLSR_PRINTF(
-      9,
+      7,
+      "%s: %s interface \"%s\": RX pkts %d (%d dups); TX pkts %d\n", 
+      PLUGIN_NAME_SHORT,
+      bmfIf->olsrIntf != NULL ? "OLSR" : "non-OLSR",
+      bmfIf->ifName,
+      bmfIf->nBmfPacketsRx,
+      bmfIf->nBmfPacketsRxDup,
+      bmfIf->nBmfPacketsTx);
+
+    olsr_printf(
+      1,
       "%s: closed %s interface \"%s\"\n", 
       PLUGIN_NAME_SHORT,
       bmfIf->olsrIntf != NULL ? "OLSR" : "non-OLSR",
       bmfIf->ifName);
 
+    /* Add totals */
+    if (bmfIf->olsrIntf != NULL)
+    {
+      totalOlsrBmfPacketsRx += bmfIf->nBmfPacketsRx;
+      totalOlsrBmfPacketsRxDup += bmfIf->nBmfPacketsRxDup;
+      totalOlsrBmfPacketsTx += bmfIf->nBmfPacketsTx;
+    }
+    else
+    {
+      totalNonOlsrBmfPacketsRx += bmfIf->nBmfPacketsRx;
+      totalNonOlsrBmfPacketsRxDup += bmfIf->nBmfPacketsRxDup;
+      totalNonOlsrBmfPacketsTx += bmfIf->nBmfPacketsTx;
+    }
+
     free(bmfIf);
-  }
+  } /* while */
   
   if (EtherTunTapFd >= 0)
   {
-    /* Restore IP spoof filter for EtherTunTap interface */
-    RestoreSpoofFilter(EtherTunTapIfName);
-
     close(EtherTunTapFd);
     nClosed++;
 
-    OLSR_PRINTF(9, "%s: closed \"%s\"\n", PLUGIN_NAME_SHORT, EtherTunTapIfName);
+    OLSR_PRINTF(7, "%s: closed \"%s\"\n", PLUGIN_NAME_SHORT, EtherTunTapIfName);
   }
 
   BmfInterfaces = NULL;
 
-  olsr_printf(1, "%s: closed %d sockets\n", PLUGIN_NAME, nClosed);
-
-  /* If there is a multicast route, delete it */
-  if (EtherTunTapIp != ETHERTUNTAPDEFAULTIP)
-  {
-    struct rtentry kernel_route;
-
-    memset(&kernel_route, 0, sizeof(struct rtentry));
-
-    ((struct sockaddr_in*)&kernel_route.rt_dst)->sin_family = AF_INET;
-    ((struct sockaddr_in*)&kernel_route.rt_gateway)->sin_family = AF_INET;
-    ((struct sockaddr_in*)&kernel_route.rt_genmask)->sin_family = AF_INET;
-
-    /* 224.0.0.0/4 */
-    ((struct sockaddr_in *)&kernel_route.rt_dst)->sin_addr.s_addr = htonl(0xE0000000);
-    ((struct sockaddr_in *)&kernel_route.rt_genmask)->sin_addr.s_addr = htonl(0xF0000000);
+  olsr_printf(1, "%s: closed %d sockets\n", PLUGIN_NAME_SHORT, nClosed);
 
-    kernel_route.rt_metric = 0;
-    kernel_route.rt_flags = RTF_UP;
-
-    kernel_route.rt_dev = EtherTunTapIfName;
-
-    if (ioctl(olsr_cnf->ioctl_s, SIOCDELRT, &kernel_route) < 0)
-    {
-      olsr_printf(
-        1,
-        "%s: error deleting multicast route via EtherTunTap interface \"%s\": %s\n",
-        PLUGIN_NAME,
-        EtherTunTapIfName,
-        strerror(errno));
-      /* Continue anyway */
-    }
-  }
+  OLSR_PRINTF(
+    7,
+    "%s: Total all OLSR interfaces    : RX pkts %d (%d dups); TX pkts %d\n",
+    PLUGIN_NAME_SHORT,
+    totalOlsrBmfPacketsRx,
+    totalOlsrBmfPacketsRxDup,
+    totalOlsrBmfPacketsTx);
+  OLSR_PRINTF(
+    7,
+    "%s: Total all non-OLSR interfaces: RX pkts %d (%d dups); TX pkts %d\n",
+    PLUGIN_NAME_SHORT,
+    totalNonOlsrBmfPacketsRx,
+    totalNonOlsrBmfPacketsRxDup,
+    totalNonOlsrBmfPacketsTx);
 }
 
 #define MAX_NON_OLSR_IFS 32
@@ -1165,7 +1780,7 @@
  * Input      : ifName - network interface (e.g. "eth0")
  * Output     : none
  * Return     : fail (0) or success (1)
- * Data Used  : none
+ * Data Used  : NonOlsrIfNames
  * ------------------------------------------------------------------------- */
 int AddNonOlsrBmfIf(const char* ifName)
 {
@@ -1193,7 +1808,7 @@
  * Input      : ifName - network interface (e.g. "eth0")
  * Output     : none
  * Return     : true (1) or false (0)
- * Data Used  : none
+ * Data Used  : NonOlsrIfNames
  * ------------------------------------------------------------------------- */
 int IsNonOlsrBmfIf(const char* ifName)
 {
@@ -1212,36 +1827,32 @@
  * Function   : CheckAndUpdateLocalBroadcast
  * Description: For an IP packet, check if the destination address is not a
  *              multicast address. If it is not, the packet is assumed to be
- *              a local broadcast packet. Update the destination address to
- *              match the passed network interface.
- * Input      : buffer - the ethernet-IP packet
+ *              a local broadcast packet. In that case, set the destination
+ *              address of the IP packet to the passed broadcast address.
+ * Input      : ipPacket - the IP packet
  *              broadAddr - the broadcast address to fill in
  * Output     : none
  * Return     : none
  * Data Used  : none
  * Notes      : See also RFC1141
  * ------------------------------------------------------------------------- */
-void CheckAndUpdateLocalBroadcast(unsigned char* buffer, struct sockaddr* broadAddr)
+void CheckAndUpdateLocalBroadcast(unsigned char* ipPacket, union olsr_ip_addr* broadAddr)
 {
   struct iphdr* iph;
   union olsr_ip_addr destIp;
 
-  assert(buffer != NULL && broadAddr != NULL);
+  assert(ipPacket != NULL && broadAddr != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   COPY_IP(&destIp, &iph->daddr);
   if (! IsMulticast(&destIp))
   {
     u_int32_t origDaddr, newDaddr;
-    struct sockaddr_in* sin;
     u_int32_t check;
 
-    /* Cast down to correct sockaddr subtype */
-    sin = (struct sockaddr_in*)broadAddr;
-    
     origDaddr = ntohl(iph->daddr);
 
-    iph->daddr = sin->sin_addr.s_addr;
+    COPY_IP(&iph->daddr, broadAddr);
     newDaddr = ntohl(iph->daddr);
 
     /* Re-calculate IP header checksum for new destination */
@@ -1259,8 +1870,8 @@
     {
       /* Re-calculate UDP/IP checksum for new destination */
 
-      int ipHeaderLen = GetIpHeaderLength(buffer);
-      struct udphdr* udph = (struct udphdr*) (buffer + IP_HDR_OFFSET + ipHeaderLen);
+      int ipHeaderLen = GetHeaderLength(ipPacket);
+      struct udphdr* udph = (struct udphdr*) (ipPacket + ipHeaderLen);
 
       /* RFC 1624, Eq. 3: HC' = ~(~HC - m + m') */
 
@@ -1277,3 +1888,91 @@
   }
 }
 
+/* -------------------------------------------------------------------------
+ * Function   : AddMulticastRoute
+ * Description: Insert a route to all multicast addresses in the kernel
+ *              routing table. The route will be via the BMF network interface.
+ * Input      : none
+ * Output     : none
+ * Return     : none
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+void AddMulticastRoute(void)
+{
+  struct rtentry kernel_route;
+  int ioctlSkfd = socket(PF_INET, SOCK_DGRAM, 0);
+  if (ioctlSkfd < 0)
+  {
+    BmfPError("socket(PF_INET) error");
+    return;
+  }
+
+  memset(&kernel_route, 0, sizeof(struct rtentry));
+
+  ((struct sockaddr_in*)&kernel_route.rt_dst)->sin_family = AF_INET;
+  ((struct sockaddr_in*)&kernel_route.rt_gateway)->sin_family = AF_INET;
+  ((struct sockaddr_in*)&kernel_route.rt_genmask)->sin_family = AF_INET;
+
+  /* 224.0.0.0/4 */
+  ((struct sockaddr_in *)&kernel_route.rt_dst)->sin_addr.s_addr = htonl(0xE0000000);
+  ((struct sockaddr_in *)&kernel_route.rt_genmask)->sin_addr.s_addr = htonl(0xF0000000);
+
+  kernel_route.rt_metric = 0;
+  kernel_route.rt_flags = RTF_UP;
+
+  kernel_route.rt_dev = EtherTunTapIfName;
+
+  if (ioctl(ioctlSkfd, SIOCADDRT, &kernel_route) < 0)
+  {
+    BmfPError("error setting multicast route via EtherTunTap interface \"%s\"", EtherTunTapIfName);
+
+    /* Continue anyway */
+  }
+  close(ioctlSkfd);
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : DeleteMulticastRoute
+ * Description: Delete the route to all multicast addresses from the kernel
+ *              routing table
+ * Input      : none
+ * Output     : none
+ * Return     : none
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+void DeleteMulticastRoute(void)
+{
+  if (EtherTunTapIp != ETHERTUNTAPDEFAULTIP)
+  {
+    struct rtentry kernel_route;
+    int ioctlSkfd = socket(PF_INET, SOCK_DGRAM, 0);
+    if (ioctlSkfd < 0)
+    {
+      BmfPError("socket(PF_INET) error");
+      return;
+    }
+
+    memset(&kernel_route, 0, sizeof(struct rtentry));
+
+    ((struct sockaddr_in*)&kernel_route.rt_dst)->sin_family = AF_INET;
+    ((struct sockaddr_in*)&kernel_route.rt_gateway)->sin_family = AF_INET;
+    ((struct sockaddr_in*)&kernel_route.rt_genmask)->sin_family = AF_INET;
+
+    /* 224.0.0.0/4 */
+    ((struct sockaddr_in *)&kernel_route.rt_dst)->sin_addr.s_addr = htonl(0xE0000000);
+    ((struct sockaddr_in *)&kernel_route.rt_genmask)->sin_addr.s_addr = htonl(0xF0000000);
+
+    kernel_route.rt_metric = 0;
+    kernel_route.rt_flags = RTF_UP;
+
+    kernel_route.rt_dev = EtherTunTapIfName;
+
+    if (ioctl(ioctlSkfd, SIOCDELRT, &kernel_route) < 0)
+    {
+      BmfPError("error deleting multicast route via EtherTunTap interface \"%s\"", EtherTunTapIfName);
+
+      /* Continue anyway */
+    }
+    close(ioctlSkfd);
+  }
+}
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.h olsrd-current/lib/bmf/src/NetworkInterfaces.h
--- olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.h	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/NetworkInterfaces.h	2007-04-22 19:40:38.000000000 +0200
@@ -38,12 +38,14 @@
  * Description: Functions to open and close sockets
  * Created    : 29 Jun 2006
  *
- * $Id: NetworkInterfaces.h,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 /* System includes */
 #include <netinet/in.h> /* struct in_addr */
 
+/* OLSR includes */
+#include "olsr_types.h" /* olsr_ip_addr */
+
 /* Plugin includes */
 #include "Packet.h" /* IFHWADDRLEN */
 
@@ -59,6 +61,10 @@
    * Only used for OLSR-enabled interfaces; set to -1 if interface is not OLSR-enabled. */
   int encapsulatingSkfd;
 
+  /* File descriptor of UDP packet socket, used for listening to encapsulation packets.
+   * Used only when PlParam "BmfMechanism" is set to "UnicastPromiscuous". */
+  int listeningSkfd;
+
   unsigned char macAddr[IFHWADDRLEN];
 
   char ifName[IFNAMSIZ];
@@ -68,10 +74,10 @@
   struct interface* olsrIntf;
 
   /* IP address of this network interface */
-  struct sockaddr intAddr;
+  union olsr_ip_addr intAddr;
 
   /* Broadcast address of this network interface */
-  struct sockaddr broadAddr;
+  union olsr_ip_addr broadAddr;
 
   #define FRAGMENT_HISTORY_SIZE 10
   struct TFragmentHistory
@@ -84,6 +90,11 @@
 
   int nextFragmentHistoryEntry;
 
+  /* Number of received and transmitted BMF packets on this interface */
+  u_int32_t nBmfPacketsRx;
+  u_int32_t nBmfPacketsRxDup;
+  u_int32_t nBmfPacketsTx;
+
   /* Next element in list */
   struct TBmfInterface* next; 
 };
@@ -97,6 +108,9 @@
 
 extern char EtherTunTapIfName[];
 
+/* 10.255.255.253 in host byte order */
+#define ETHERTUNTAPDEFAULTIP 0x0AFFFFFD
+
 extern u_int32_t EtherTunTapIp;
 extern u_int32_t EtherTunTapIpMask;
 extern u_int32_t EtherTunTapIpBroadcast;
@@ -106,15 +120,29 @@
 enum TTunOrTap { TT_TUN = 0, TT_TAP };
 extern enum TTunOrTap TunOrTap;
 
+enum TBmfMechanism { BM_BROADCAST = 0, BM_UNICAST_PROMISCUOUS };
+extern enum TBmfMechanism BmfMechanism;
+
 int SetBmfInterfaceName(const char* ifname);
 int SetBmfInterfaceType(const char* iftype);
 int SetBmfInterfaceIp(const char* ip);
 int SetCapturePacketsOnOlsrInterfaces(const char* enable);
+int SetBmfMechanism(const char* mechanism);
+int DeactivateSpoofFilter(void);
+void RestoreSpoofFilter(void);
+struct link_entry* GetBestNeighbor(
+  struct TBmfInterface* intf,
+  union olsr_ip_addr* source,
+  union olsr_ip_addr* forwardedBy,
+  union olsr_ip_addr* forwardedTo,
+  int* multipleNeighbors);
 int CreateBmfNetworkInterfaces(struct interface* skipThisIntf);
 void AddInterface(struct interface* newIntf);
 void CloseBmfNetworkInterfaces(void);
 int AddNonOlsrBmfIf(const char* ifName);
 int IsNonOlsrBmfIf(const char* ifName);
-void CheckAndUpdateLocalBroadcast(unsigned char* buffer, struct sockaddr* broadAddr);
+void CheckAndUpdateLocalBroadcast(unsigned char* ipPacket, union olsr_ip_addr* broadAddr);
+void AddMulticastRoute(void);
+void DeleteMulticastRoute(void);
 
 #endif /* _BMF_NETWORKINTERFACES_H */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/olsrd_plugin.c olsrd-current/lib/bmf/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/bmf/src/olsrd_plugin.c	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/olsrd_plugin.c	2007-04-22 19:40:39.000000000 +0200
@@ -35,12 +35,11 @@
  * Description: Interface to the OLSRD plugin system
  * Created    : 29 Jun 2006
  *
- * $Id: olsrd_plugin.c,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 /* System includes */
 #include <assert.h> /* assert() */
-#include <stdio.h>
+#include <stddef.h> /* NULL */
 
 /* OLSRD includes */
 #include "olsrd_plugin.h"
@@ -66,7 +65,7 @@
  * Notes      : Called by main OLSRD (olsr_load_dl) to check plugin interface
  *              version
  * ------------------------------------------------------------------------- */
-int olsrd_plugin_interface_version()
+int olsrd_plugin_interface_version(void)
 {
   return OLSRD_PLUGIN_INTERFACE_VERSION;
 }
@@ -80,7 +79,7 @@
  * Data Used  : olsr_cnf
  * Notes      : Called by main OLSRD (init_olsr_plugin) to initialize plugin
  * ------------------------------------------------------------------------- */
-int olsrd_plugin_init()
+int olsrd_plugin_init(void)
 {
   /* Check validity */
   if (olsr_cnf->ip_version != AF_INET)
@@ -110,7 +109,7 @@
  * Data Used  : none
  * Notes      : Called by my_fini() at unload of shared object
  * ------------------------------------------------------------------------- */
-void olsr_plugin_exit()
+void olsr_plugin_exit(void)
 {
   CloseBmf();
 }
@@ -141,7 +140,7 @@
  * Data Used  : none
  * Notes      : Called at load of shared object
  * ------------------------------------------------------------------------- */
-static void my_init()
+static void my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
@@ -158,7 +157,7 @@
  * Data Used  : none
  * Notes      : Called at unload of shared object
  * ------------------------------------------------------------------------- */
-static void my_fini()
+static void my_fini(void)
 {
   olsr_plugin_exit();
 }
